# Profiling

Glasgow Haskell comes with a time and space profiling system. Its purpose is to help you improve your understanding of your program's execution behaviour, so you can improve it.

Any comments, suggestions and/or improvements you have are welcome. Recommended “profiling tricks” would be especially cool!

Profiling a program is a three-step process:

1. Re-compile your program for profiling with the `-prof` option, and probably one of the `-auto` or `-auto-all` options. These options are described in more detail in

2. Run your program with one of the profiling options, eg. `+RTS -p -RTS`. This generates a file of profiling information.

3. Examine the generated profiling information, using one of GHC's profiling tools. The tool to use will depend on the kind of profiling information generated.

## Cost centres and cost-centre stacks

GHC's profiling system assigns costs to cost centres. A cost is simply the time or space required to evaluate an expression. Cost centres are program annotations around expressions; all costs incurred by the annotated expression are assigned to the enclosing cost centre. Furthermore, GHC will remember the stack of enclosing cost centres for any given expression at run-time and generate a call-graph of cost attributions.

Let's take a look at an example:

    main = print (nfib 25)
    nfib n = if n < 2 then 1 else nfib (n-1) + nfib (n-2)

Compile and run this program as follows:

    $ ghc -prof -auto-all -o Main Main.hs
    $ ./Main +RTS -p
    121393
    $

When a GHC-compiled program is run with the `-p` RTS option, it generates a file called `<prog>.prof`. In this case, the file will contain something like this:

              Fri May 12 14:06 2000 Time and Allocation Profiling Report  (Final)

               Main +RTS -p -RTS

            total time  =        0.14 secs   (7 ticks @ 20 ms)
            total alloc =   8,741,204 bytes  (excludes profiling overheads)

    COST CENTRE          MODULE     %time %alloc

    nfib                 Main       100.0  100.0

                                                  individual     inherited
    COST CENTRE              MODULE      entries %time %alloc   %time %alloc

    MAIN                     MAIN             0    0.0   0.0    100.0 100.0
     main                    Main             0    0.0   0.0      0.0   0.0
     CAF                     PrelHandle       3    0.0   0.0      0.0   0.0
     CAF                     PrelAddr         1    0.0   0.0      0.0   0.0
     CAF                     Main             6    0.0   0.0    100.0 100.0
      main                   Main             1    0.0   0.0    100.0 100.0
       nfib                  Main        242785  100.0 100.0    100.0 100.0

The first part of the file gives the program name and options, and the total time and total memory allocation measured during the run of the program (note that the total memory allocation figure isn't the same as the amount of live memory needed by the program at any one time; the latter can be determined using heap profiling, which we will describe shortly).

The second part of the file is a break-down by cost centre of the most costly functions in the program. In this case, there was only one significant function in the program, namely `nfib`, and it was responsible for 100&percnt; of both the time and allocation costs of the program.

The third and final section of the file gives a profile break-down by cost-centre stack. This is roughly a call-graph profile of the program. In the example above, it is clear that the costly call to `nfib` came from `main`.

The time and allocation incurred by a given part of the program is displayed in two ways: “individual”, which are the costs incurred by the code covered by this cost centre stack alone, and “inherited”, which includes the costs incurred by all the children of this node.

The usefulness of cost-centre stacks is better demonstrated by modifying the example slightly:

    main = print (f 25 + g 25)
    f n  = nfib n
    g n  = nfib (n `div` 2)
    nfib n = if n < 2 then 1 else nfib (n-1) + nfib (n-2)

Compile and run this program as before, and take a look at the new profiling results:

    COST CENTRE              MODULE         scc  %time %alloc   %time %alloc

    MAIN                     MAIN             0    0.0   0.0    100.0 100.0
     main                    Main             0    0.0   0.0      0.0   0.0
     CAF                     PrelHandle       3    0.0   0.0      0.0   0.0
     CAF                     PrelAddr         1    0.0   0.0      0.0   0.0
     CAF                     Main             9    0.0   0.0    100.0 100.0
      main                   Main             1    0.0   0.0    100.0 100.0
       g                     Main             1    0.0   0.0      0.0   0.2
        nfib                 Main           465    0.0   0.2      0.0   0.2
       f                     Main             1    0.0   0.0    100.0  99.8
        nfib                 Main        242785  100.0  99.8    100.0  99.8

Now although we had two calls to `nfib` in the program, it is immediately clear that it was the call from `f` which took all the time.

The actual meaning of the various columns in the output is:

entries

  The number of times this particular point in the call graph was entered.

individual &percnt;time

  The percentage of the total run time of the program spent at this point in the call graph.

individual &percnt;alloc

  The percentage of the total memory allocations (excluding profiling overheads) of the program made by this call.

inherited &percnt;time

  The percentage of the total run time of the program spent below this point in the call graph.

inherited &percnt;alloc

  The percentage of the total memory allocations (excluding profiling overheads) of the program made by this call and all of its sub-calls.

In addition you can use the `-P` RTS option
to get the following additional information:

`ticks`

  The raw number of time “ticks” which were attributed to this cost-centre; from this, we get the `&percnt;time` figure mentioned above.

`bytes`

  Number of bytes allocated in the heap while in this cost-centre; again, this is the raw number from which we get the `&percnt;alloc` figure mentioned above.

What about recursive functions, and mutually recursive groups of functions? Where are the costs attributed? Well, although GHC does keep information about which groups of functions called each other recursively, this information isn't displayed in the basic time and allocation profile, instead the call-graph is flattened into a tree. The XML profiling tool (described in ) will be able to display real loops in the call-graph.

### Inserting cost centres by hand

Cost centres are just program annotations. When you say `-auto-all` to the compiler, it automatically inserts a cost centre annotation around every top-level function in your program, but you are entirely free to add the cost centre annotations yourself.

The syntax of a cost centre annotation is

         {-# SCC "name" #-} <expression>

where `"name"` is an arbitrary string, that will become the name of your cost centre as it appears in the profiling output, and `<expression>` is any Haskell expression. An `SCC` annotation extends as far to the right as possible when parsing.

### Rules for attributing costs

The cost of evaluating any expression in your program is attributed to a cost-centre stack using the following rules:

- If the expression is part of the one-off costs of evaluating the enclosing top-level definition, then costs are attributed to the stack of lexically enclosing `SCC` annotations on top of the special `CAF` cost-centre.

- Otherwise, costs are attributed to the stack of lexically-enclosing `SCC` annotations, appended to the cost-centre stack in effect at the call site of the current top-level definition The call-site is just the place in the source code which mentions the particular function or variable.. Notice that this is a recursive definition.

- Time spent in foreign code (see ) is always attributed to the cost centre in force at the Haskell call-site of the foreign function.

What do we mean by one-off costs? Well, Haskell is a lazy language, and certain expressions are only ever evaluated once. For example, if we write:

    x = nfib 25

then `x` will only be evaluated once (if at all), and subsequent demands for `x` will immediately get to see the cached result. The definition `x` is called a CAF (Constant Applicative Form), because it has no arguments.

For the purposes of profiling, we say that the expression `nfib 25` belongs to the one-off costs of evaluating `x`.

Since one-off costs aren't strictly speaking part of the call-graph of the program, they are attributed to a special top-level cost centre, `CAF`. There may be one `CAF` cost centre for each module (the default), or one for each top-level definition with any one-off costs (this behaviour can be selected by giving GHC the `-caf-all` flag).

If you think you have a weird profile, or the call-graph doesn't look like you expect it to, feel free to send it (and your program) to us at glasgow-haskell-bugs@haskell.org.

## Compiler options for profiling

`-prof`:

  To make use of the profiling system all modules must be compiled and linked with the `-prof` option. Any `SCC` annotations you've put in your source will spring to life.

  Without a `-prof` option, your `SCC`s are ignored; so you can compile `SCC`-laden code without changing it.

There are a few other profiling-related compilation options. Use them in addition to `-prof`. These do not have to be used consistently for all modules in a program.

`-auto`:

  GHC will automatically add `&lowbar;scc&lowbar;` constructs for all top-level, exported functions.

`-auto-all`:

  All top-level functions, exported or not, will be automatically `&lowbar;scc&lowbar;`'d.

`-caf-all`:

  The costs of all CAFs in a module are usually attributed to one “big” CAF cost-centre. With this option, all CAFs get their own cost-centre. An “if all else fails” option…

`-ignore-scc`:

  Ignore any `&lowbar;scc&lowbar;` constructs, so a module which already has `&lowbar;scc&lowbar;`s can be compiled for profiling with the annotations ignored.

## Time and allocation profiling

To generate a time and allocation profile, give one of the following RTS options to the compiled program when you run it (RTS options should be enclosed between `+RTS...-RTS` as usual):

`-p` or `-P`:

  The `-p` option produces a standard time profile report. It is written into the file `program.prof`.

  The `-P` option produces a more detailed report containing the actual time and allocation data as well. (Not used much.)

`-px`:

  The `-px` option generates profiling information in the XML format understood by our new profiling tool, see .

`-xc`

  This option makes use of the extra information maintained by the cost-centre-stack profiler to provide useful information about the location of runtime errors. See .

## Profiling memory usage

In addition to profiling the time and allocation behaviour of your program, you can also generate a graph of its memory usage over time. This is useful for detecting the causes of space leaks, when your program holds on to more memory at run-time that it needs to. Space leaks lead to longer run-times due to heavy garbage collector activity, and may even cause the program to run out of memory altogether.

To generate a heap profile from your program:

1. Compile the program for profiling ().

2. Run it with one of the heap profiling options described below (eg. `-hc` for a basic producer profile). This generates the file `prog.hp`.

3. Run `hp2ps` to produce a Postscript file, `prog.ps`. The `hp2ps` utility is described in detail in .

4. Display the heap profile using a postscript viewer such as Ghostview, or print it out on a Postscript-capable printer.

### RTS options for heap profiling

There are several different kinds of heap profile that can be generated. All the different profile types yield a graph of live heap against time, but they differ in how the live heap is broken down into bands. The following RTS options select which break-down to use:

`-hc`

  Breaks down the graph by the cost-centre stack which produced the data.

`-hm`

  Break down the live heap by the module containing the code which produced the data.

`-hd`

  Breaks down the graph by closure description. For actual data, the description is just the constructor name, for other closures it is a compiler-generated string identifying the closure.

`-hy`

  Breaks down the graph by type. For closures which have function type or unknown/polymorphic type, the string will represent an approximation to the actual type.

`-hr`

  Break down the graph by retainer set. Retainer profiling is described in more detail below ().

`-hb`

  Break down the graph by biography. Biographical profiling is described in more detail below ().

In addition, the profile can be restricted to heap data which satisfies certain criteria - for example, you might want to display a profile by type but only for data produced by a certain module, or a profile by retainer for a certain type of data. Restrictions are specified as follows:

`-hc` name,...

  Restrict the profile to closures produced by cost-centre stacks with one of the specified cost centres at the top.

`-hC` name,...

  Restrict the profile to closures produced by cost-centre stacks with one of the specified cost centres anywhere in the stack.

`-hm` module,...

  Restrict the profile to closures produced by the specified modules.

`-hd` desc,...

  Restrict the profile to closures with the specified description strings.

`-hy` type,...

  Restrict the profile to closures with the specified types.

`-hr` cc,...

  Restrict the profile to closures with retainer sets containing cost-centre stacks with one of the specified cost centres at the top.

`-hb` bio,...

  Restrict the profile to closures with one of the specified biographies, where bio is one of `lag`, `drag`, `void`, or `use`.

For example, the following options will generate a retainer profile restricted to `Branch` and `Leaf` constructors:

    prog +RTS -hr -hdBranch,Leaf

There can only be one "break-down" option (eg. `-hr` in the example above), but there is no limit on the number of further restrictions that may be applied. All the options may be combined, with one exception: GHC doesn't currently support mixing the `-hr` and `-hb` options.

There are two more options which relate to heap profiling:

`-isecs`:

  Set the profiling (sampling) interval to secs seconds (the default is 0.1 second). Fractions are allowed: for example `-i0.2` will get 5 samples per second. This only affects heap profiling; time profiles are always sampled on a 1/50 second frequency.

`-xt`

  Include the memory occupied by threads in a heap profile. Each thread takes up a small area for its thread state in addition to the space allocated for its stack (stacks normally start small and then grow as necessary).

  This includes the main thread, so using `-xt` is a good way to see how much stack space the program is using.

  Memory occupied by threads and their stacks is labelled as “TSO” when displaying the profile by closure description or type description.

### Retainer Profiling

Retainer profiling is designed to help answer questions like why is this data being retained?. We start by defining what we mean by a retainer:

> A retainer is either the system stack, or an unevaluated closure (thunk).

In particular, constructors are not retainers.

An object B retains object A if (i) B is a retainer object and (ii) object A can be reached by recursively following pointers starting from object B, but not meeting any other retainer objects on the way. Each live object is retained by one or more retainer objects, collectively called its retainer set, or its retainer set, or its retainers.

When retainer profiling is requested by giving the program the `-hr` option, a graph is generated which is broken down by retainer set. A retainer set is displayed as a set of cost-centre stacks; because this is usually too large to fit on the profile graph, each retainer set is numbered and shown abbreviated on the graph along with its number, and the full list of retainer sets is dumped into the file `prog.prof`.

Retainer profiling requires multiple passes over the live heap in order to discover the full retainer set for each object, which can be quite slow. So we set a limit on the maximum size of a retainer set, where all retainer sets larger than the maximum retainer set size are replaced by the special set `MANY`. The maximum set size defaults to 8 and can be altered with the `-R` RTS option:

`-R` size

  Restrict the number of elements in a retainer set to size (default 8).

#### Hints for using retainer profiling

The definition of retainers is designed to reflect a common cause of space leaks: a large structure is retained by an unevaluated computation, and will be released once the computation is forced. A good example is looking up a value in a finite map, where unless the lookup is forced in a timely manner the unevaluated lookup will cause the whole mapping to be retained. These kind of space leaks can often be eliminated by forcing the relevant computations to be performed eagerly, using `seq` or strictness annotations on data constructor fields.

Often a particular data structure is being retained by a chain of unevaluated closures, only the nearest of which will be reported by retainer profiling - for example A retains B, B retains C, and C retains a large structure. There might be a large number of Bs but only a single A, so A is really the one we're interested in eliminating. However, retainer profiling will in this case report B as the retainer of the large structure. To move further up the chain of retainers, we can ask for another retainer profile but this time restrict the profile to B objects, so we get a profile of the retainers of B:

    prog +RTS -hr -hcB

This trick isn't foolproof, because there might be other B closures in the heap which aren't the retainers we are interested in, but we've found this to be a useful technique in most cases.

### Biographical Profiling

A typical heap object may be in one of the following four states at each point in its lifetime:

- The lag stage, which is the time between creation and the first use of the object,

- the use stage, which lasts from the first use until the last use of the object, and

- The drag stage, which lasts from the final use until the last reference to the object is dropped.

- An object which is never used is said to be in the void state for its whole lifetime.

A biographical heap profile displays the portion of the live heap in each of the four states listed above. Usually the most interesting states are the void and drag states: live heap in these states is more likely to be wasted space than heap in the lag or use states.

It is also possible to break down the heap in one or more of these states by a different criteria, by restricting a profile by biography. For example, to show the portion of the heap in the drag or void state by producer:

    prog +RTS -hc -hbdrag,void

Once you know the producer or the type of the heap in the drag or void states, the next step is usually to find the retainer(s):

    prog +RTS -hr -hccc...

NOTE: this two stage process is required because GHC cannot currently profile using both biographical and retainer information simultaneously.

### Actual memory residency

How does the heap residency reported by the heap profiler relate to the actual memory residency of your program when you run it? You might see a large discrepancy between the residency reported by the heap profiler, and the residency reported by tools on your system (eg. `ps` or `top` on Unix, or the Task Manager on Windows). There are several reasons for this:

- There is an overhead of profiling itself, which is subtracted from the residency figures by the profiler. This overhead goes away when compiling without profiling support, of course. The space overhead is currently 2 extra words per heap object, which probably results in about a 30% overhead.

- Garbage collection requires more memory than the actual residency. The factor depends on the kind of garbage collection algorithm in use: a major GC in the standard generation copying collector will usually require 3L bytes of memory, where L is the amount of live data. This is because by default (see the `+RTS -F` option) we allow the old generation to grow to twice its size (2L) before collecting it, and we require additionally L bytes to copy the live data into. When using compacting collection (see the `+RTS -c` option), this is reduced to 2L, and can further be reduced by tweaking the `-F` option. Also add the size of the allocation area (currently a fixed 512Kb).

- The stack isn't counted in the heap profile by default. See the `+RTS -xt` option.

- The program text itself, the C stack, any non-heap data (eg. data allocated by foreign libraries, and data allocated by the RTS), and `mmap()`'d memory are not counted in the heap profile.

## Graphical time/allocation profile

You can view the time and allocation profiling graph of your program graphically, using `ghcprof`. This is a new tool with GHC 4.08, and will eventually be the de-facto standard way of viewing GHC profiles Actually this isn't true any more, we are working on a new tool for displaying heap profiles using Gtk+HS, so `ghcprof` may go away at some point in the future.

To run `ghcprof`, you need uDraw(Graph) installed, which can be obtained from uDraw(Graph). Install one of the binary distributions, and set your `UDG_HOME` environment variable to point to the installation directory.

`ghcprof` uses an XML-based profiling log format, and you therefore need to run your program with a different option: `-px`. The file generated is still called `<prog>.prof`. To see the profile, run `ghcprof` like this:

    $ ghcprof <prog>.prof

which should pop up a window showing the call-graph of your program in glorious detail. More information on using `ghcprof` can be found at The Cost-Centre Stack Profiling Tool for GHC.

## `hp2ps`––heap profile to PostScript

Usage:

    hp2ps [flags] [<file>[.hp]]

The program `hp2ps`
converts a heap profile as produced by the `-h<break-down>` runtime option into a PostScript graph of the heap profile. By convention, the file to be processed by `hp2ps` has a `.hp` extension. The PostScript output is written to `<file>@.ps`. If `<file>` is omitted entirely, then the program behaves as a filter.

`hp2ps` is distributed in `ghc/utils/hp2ps` in a GHC source distribution. It was originally developed by Dave Wakeling as part of the HBC/LML heap profiler.

The flags are:

`-d`

  In order to make graphs more readable, `hp2ps` sorts the shaded bands for each identifier. The default sort ordering is for the bands with the largest area to be stacked on top of the smaller ones. The `-d` option causes rougher bands (those representing series of values with the largest standard deviations) to be stacked on top of smoother ones.

`-b`

  Normally, `hp2ps` puts the title of the graph in a small box at the top of the page. However, if the JOB string is too long to fit in a small box (more than 35 characters), then `hp2ps` will choose to use a big box instead. The `-b` option forces `hp2ps` to use a big box.

`-e<float>[in&verbar;mm&verbar;pt]`

  Generate encapsulated PostScript suitable for inclusion in LaTeX documents. Usually, the PostScript graph is drawn in landscape mode in an area 9 inches wide by 6 inches high, and `hp2ps` arranges for this area to be approximately centred on a sheet of a4 paper. This format is convenient of studying the graph in detail, but it is unsuitable for inclusion in LaTeX documents. The `-e` option causes the graph to be drawn in portrait mode, with float specifying the width in inches, millimetres or points (the default). The resulting PostScript file conforms to the Encapsulated PostScript (EPS) convention, and it can be included in a LaTeX document using Rokicki's dvi-to-PostScript converter `dvips`.

`-g`

  Create output suitable for the `gs` PostScript previewer (or similar). In this case the graph is printed in portrait mode without scaling. The output is unsuitable for a laser printer.

`-l`

  Normally a profile is limited to 20 bands with additional identifiers being grouped into an `OTHER` band. The `-l` flag removes this 20 band and limit, producing as many bands as necessary. No key is produced as it won't fit!. It is useful for creation time profiles with many bands.

`-m<int>`

  Normally a profile is limited to 20 bands with additional identifiers being grouped into an `OTHER` band. The `-m` flag specifies an alternative band limit (the maximum is 20).

  `-m0` requests the band limit to be removed. As many bands as necessary are produced. However no key is produced as it won't fit! It is useful for displaying creation time profiles with many bands.

`-p`

  Use previous parameters. By default, the PostScript graph is automatically scaled both horizontally and vertically so that it fills the page. However, when preparing a series of graphs for use in a presentation, it is often useful to draw a new graph using the same scale, shading and ordering as a previous one. The `-p` flag causes the graph to be drawn using the parameters determined by a previous run of `hp2ps` on `file`. These are extracted from `file@.aux`.

`-s`

  Use a small box for the title.

`-t<float>`

  Normally trace elements which sum to a total of less than 1&percnt; of the profile are removed from the profile. The `-t` option allows this percentage to be modified (maximum 5&percnt;).

  `-t0` requests no trace elements to be removed from the profile, ensuring that all the data will be displayed.

`-c`

  Generate colour output.

`-y`

  Ignore marks.

`-?`

  Print out usage information.

### Manipulating the hp file

(Notes kindly offered by Jan-Willhem Maessen.)

The `FOO.hp` file produced when you ask for the heap profile of a program `FOO` is a text file with a particularly simple structure. Here's a representative example, with much of the actual data omitted:

    JOB "FOO -hC"
    DATE "Thu Dec 26 18:17 2002"
    SAMPLE_UNIT "seconds"
    VALUE_UNIT "bytes"
    BEGIN_SAMPLE 0.00
    END_SAMPLE 0.00
    BEGIN_SAMPLE 15.07
      ... sample data ...
    END_SAMPLE 15.07
    BEGIN_SAMPLE 30.23
      ... sample data ...
    END_SAMPLE 30.23
    ... etc.
    BEGIN_SAMPLE 11695.47
    END_SAMPLE 11695.47

The first four lines (`JOB`, `DATE`, `SAMPLE_UNIT`, `VALUE_UNIT`) form a header. Each block of lines starting with `BEGIN_SAMPLE` and ending with `END_SAMPLE` forms a single sample (you can think of this as a vertical slice of your heap profile). The hp2ps utility should accept any input with a properly-formatted header followed by a series of *complete* samples.

### Zooming in on regions of your profile

You can look at particular regions of your profile simply by loading a copy of the `.hp` file into a text editor and deleting the unwanted samples. The resulting `.hp` file can be run through `hp2ps` and viewed or printed.

### Viewing the heap profile of a running program

The `.hp` file is generated incrementally as your program runs. In principle, running `hp2ps` on the incomplete file should produce a snapshot of your program's heap usage. However, the last sample in the file may be incomplete, causing `hp2ps` to fail. If you are using a machine with UNIX utilities installed, it's not too hard to work around this problem (though the resulting command line looks rather Byzantine):

      head -`fgrep -n END_SAMPLE FOO.hp | tail -1 | cut -d : -f 1` FOO.hp \
        | hp2ps > FOO.ps

The command `fgrep -n END_SAMPLE FOO.hp` finds the end of every complete sample in `FOO.hp`, and labels each sample with its ending line number. We then select the line number of the last complete sample using `tail` and `cut`. This is used as a parameter to `head`; the result is as if we deleted the final incomplete sample from `FOO.hp`. This results in a properly-formatted .hp file which we feed directly to `hp2ps`.

### Viewing a heap profile in real time

The `gv` and `ghostview` programs have a "watch file" option can be used to view an up-to-date heap profile of your program as it runs. Simply generate an incremental heap profile as described in the previous section. Run `gv` on your profile:

      gv -watch -seascape FOO.ps

If you forget the `-watch` flag you can still select "Watch file" from the "State" menu. Now each time you generate a new profile `FOO.ps` the view will update automatically.

This can all be encapsulated in a little script:

      #!/bin/sh
      head -`fgrep -n END_SAMPLE FOO.hp | tail -1 | cut -d : -f 1` FOO.hp \
        | hp2ps > FOO.ps
      gv -watch -seascape FOO.ps &
      while [ 1 ] ; do
        sleep 10 # We generate a new profile every 10 seconds.
        head -`fgrep -n END_SAMPLE FOO.hp | tail -1 | cut -d : -f 1` FOO.hp \
          | hp2ps > FOO.ps
      done

Occasionally `gv` will choke as it tries to read an incomplete copy of `FOO.ps` (because `hp2ps` is still running as an update occurs). A slightly more complicated script works around this problem, by using the fact that sending a SIGHUP to gv will cause it to re-read its input file:

      #!/bin/sh
      head -`fgrep -n END_SAMPLE FOO.hp | tail -1 | cut -d : -f 1` FOO.hp \
        | hp2ps > FOO.ps
      gv FOO.ps &
      gvpsnum=$!
      while [ 1 ] ; do
        sleep 10
        head -`fgrep -n END_SAMPLE FOO.hp | tail -1 | cut -d : -f 1` FOO.hp \
          | hp2ps > FOO.ps
        kill -HUP $gvpsnum
      done

## Using “ticky-ticky” profiling (for implementors)

(ToDo: document properly.)

It is possible to compile Glasgow Haskell programs so that they will count lots and lots of interesting things, e.g., number of updates, number of data constructors entered, etc., etc. We call this “ticky-ticky” profiling,
because that's the sound a Sun4 makes when it is running up all those counters (slowly).

Ticky-ticky profiling is mainly intended for implementors; it is quite separate from the main “cost-centre” profiling system, intended for all users everywhere.

To be able to use ticky-ticky profiling, you will need to have built appropriate libraries and things when you made the system. See “Customising what libraries to build,” in the installation guide.

To get your compiled program to spit out the ticky-ticky numbers, use a `-r` RTS option
. See .

Compiling your program with the `-ticky` switch yields an executable that performs these counts. Here is a sample ticky-ticky statistics file, generated by the invocation `foo +RTS -rfoo.ticky`.

     foo +RTS -rfoo.ticky

    ALLOCATIONS: 3964631 (11330900 words total: 3999476 admin, 6098829 goods, 1232595 slop)
                                    total words:        2     3     4     5    6+
      69647 (  1.8%) function values                 50.0  50.0   0.0   0.0   0.0
    2382937 ( 60.1%) thunks                           0.0  83.9  16.1   0.0   0.0
    1477218 ( 37.3%) data values                     66.8  33.2   0.0   0.0   0.0
          0 (  0.0%) big tuples
          2 (  0.0%) black holes                      0.0 100.0   0.0   0.0   0.0
          0 (  0.0%) prim things
      34825 (  0.9%) partial applications             0.0   0.0   0.0 100.0   0.0
          2 (  0.0%) thread state objects             0.0   0.0   0.0   0.0 100.0

    Total storage-manager allocations: 3647137 (11882004 words)
            [551104 words lost to speculative heap-checks]

    STACK USAGE:

    ENTERS: 9400092  of which 2005772 (21.3%) direct to the entry code
                      [the rest indirected via Node's info ptr]
    1860318 ( 19.8%) thunks
    3733184 ( 39.7%) data values
    3149544 ( 33.5%) function values
                      [of which 1999880 (63.5%) bypassed arg-satisfaction chk]
     348140 (  3.7%) partial applications
     308906 (  3.3%) normal indirections
          0 (  0.0%) permanent indirections

    RETURNS: 5870443
    2137257 ( 36.4%) from entering a new constructor
                      [the rest from entering an existing constructor]
    2349219 ( 40.0%) vectored [the rest unvectored]

    RET_NEW:         2137257:  32.5% 46.2% 21.3%  0.0%  0.0%  0.0%  0.0%  0.0%  0.0%
    RET_OLD:         3733184:   2.8% 67.9% 29.3%  0.0%  0.0%  0.0%  0.0%  0.0%  0.0%
    RET_UNBOXED_TUP:       2:   0.0%  0.0%100.0%  0.0%  0.0%  0.0%  0.0%  0.0%  0.0%

    RET_VEC_RETURN : 2349219:   0.0%  0.0%100.0%  0.0%  0.0%  0.0%  0.0%  0.0%  0.0%

    UPDATE FRAMES: 2241725 (0 omitted from thunks)
    SEQ FRAMES:    1
    CATCH FRAMES:  1
    UPDATES: 2241725
          0 (  0.0%) data values
      34827 (  1.6%) partial applications
                      [2 in place, 34825 allocated new space]
    2206898 ( 98.4%) updates to existing heap objects (46 by squeezing)
    UPD_CON_IN_NEW:         0:       0      0      0      0      0      0      0      0      0
    UPD_PAP_IN_NEW:     34825:       0      0      0  34825      0      0      0      0      0

    NEW GEN UPDATES: 2274700 ( 99.9%)

    OLD GEN UPDATES: 1852 (  0.1%)

    Total bytes copied during GC: 190096

    **************************************************
    3647137 ALLOC_HEAP_ctr
    11882004 ALLOC_HEAP_tot
      69647 ALLOC_FUN_ctr
      69647 ALLOC_FUN_adm
      69644 ALLOC_FUN_gds
      34819 ALLOC_FUN_slp
      34831 ALLOC_FUN_hst_0
      34816 ALLOC_FUN_hst_1
          0 ALLOC_FUN_hst_2
          0 ALLOC_FUN_hst_3
          0 ALLOC_FUN_hst_4
    2382937 ALLOC_UP_THK_ctr
          0 ALLOC_SE_THK_ctr
     308906 ENT_IND_ctr
          0 E!NT_PERM_IND_ctr requires +RTS -Z
    [... lots more info omitted ...]
          0 GC_SEL_ABANDONED_ctr
          0 GC_SEL_MINOR_ctr
          0 GC_SEL_MAJOR_ctr
          0 GC_FAILED_PROMOTION_ctr
      47524 GC_WORDS_COPIED_ctr

The formatting of the information above the row of asterisks is subject to change, but hopefully provides a useful human-readable summary. Below the asterisks all counters maintained by the ticky-ticky system are dumped, in a format intended to be machine-readable: zero or more spaces, an integer, a space, the counter name, and a newline.

In fact, not all counters are necessarily dumped; compile- or run-time flags can render certain counters invalid. In this case, either the counter will simply not appear, or it will appear with a modified counter name, possibly along with an explanation for the omission (notice `ENT&lowbar;PERM&lowbar;IND&lowbar;ctr` appears with an inserted `!` above). Software analysing this output should always check that it has the counters it expects. Also, beware: some of the counters can have large values!